import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_mylibrary/flutter_mylibrary.dart';
import 'package:flutter_mylibrary/widget/video/video_widget.dart';
import 'package:video_player/video_player.dart';
import 'easy_video_player_contrller.dart';


// ignore: must_be_immutable
class EasyVideoPlayer extends StatefulWidget{

  EasyVideoPlayerController easyVideoPlayerController;

  EasyVideoPlayer({EasyVideoPlayerController controller}){
    this.easyVideoPlayerController = controller;
  }

  @override
  State<StatefulWidget> createState() {
    return EasyVideoPlayerState();
  }
}


class EasyVideoPlayerState extends State<EasyVideoPlayer>{

  VideoPlayerController  _videoPlayerController;

  EasyVideoPlayerController _easyVideoPlayerController;


  EasyVideoSizeType easyVideoSizeType;


  @override
  void initState() {
    super.initState();
    _easyVideoPlayerController = widget.easyVideoPlayerController;
    _videoPlayerController = _easyVideoPlayerController?.videoPlayerController;

    if(_easyVideoPlayerController.autoPlay){
      _videoPlayerController.play();
    }
  }

  @override
  Widget build(BuildContext context) {
    return InheritedProvider(
      create: (context) => _easyVideoPlayerController,
      updateShouldNotify: (previous, current) => previous != current,
      child: VideoWidget(),
    );
  }
}


